hdu 2639 Bone Collector II DP(第i最优决策)

来源:互联网 发布:查杀木马软件 编辑:程序博客网 时间:2024/04/30 09:25

The title of this problem is familiar,isn’t it?yeah,if you had took part in the “Rookie Cup” competition,you must have seem this title.If you haven’t seen it before,it doesn’t matter,I will give you a link:

Here is the link: http://acm.hdu.edu.cn/showproblem.php?pid=2602

Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.

If the total number of different values is less than K,just ouput 0.
Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Output
One integer per line representing the K-th maximum of the total value (this number will be less than 2 31).
Sample Input
3
5 10 2
1 2 3 4 5
5 4 3 2 1
5 10 12
1 2 3 4 5
5 4 3 2 1
5 10 16
1 2 3 4 5
5 4 3 2 1
Sample Output
12
2
0

题意 给定n,m,k 物品类型数量,背包总重量,和第k个最优情况,把二维压缩成一维,然后用再加一维k,记录每一阶段的前k个最优解,因为在前k的每个最优决策,在最新阶段都要执行两种决策仿或者不放来更新最新的前k个决策,这样会产生2k个决策(因为是01背包,在单个阶段里面的决策不会互相干扰),放进(A,B数组里面),然后再筛选出k个最优的决策。

#include <iostream>#include <algorithm>#include <cstring>using namespace std;int n,vol,k;int dp[1005][35],value[105],cost[105],A[35],B[35];void kth_ZeroOnePack(){    memset(dp,0,sizeof(dp));    int i,j,kk,a,b,c;    for(i=1;i<=n;i++)    {        for(j=vol;j>=cost[i];j--)        {            for(kk=1;kk<=k;kk++)            {                A[kk]=dp[j-cost[i]][kk]+value[i];                B[kk]=dp[j][kk];            }            A[kk]=B[kk]=-1;            a=b=c=1;            while(c<=k&&(A[a]!=-1||B[b]!=-1))            {                if(A[a]>B[b])                    dp[j][c]=A[a],++a;                else                    dp[j][c]=B[b],++b;                if(dp[j][c]!=dp[j][c-1])                    ++c;            }        }    }    cout<<dp[vol][k]<<endl;}int main(){    int tCase;    cin>>tCase;    while(tCase--)    {        cin>>n>>vol>>k;        for(int i=1;i<=n;i++) cin>>value[i];        for(int j=1;j<=n;j++) cin>>cost[j];        kth_ZeroOnePack();    }}
0 0